/***************************************************************************************

赤外線リモコンコード解析ソフト for Arduino

本ソースリストおよびソフトウェアは、ライセンスフリーです。
利用、編集、再配布等が自由に行えますが、著作権表示の改変は禁止します。

                                                 Copyright (c) 2009-2014 Wataru KUNINO
                                                 http://www.geocities.jp/bokunimowakaru/
***************************************************************************************/

/***************************************************************************************

2017/04 H.Iwaoka
 DigiSpark互換機で動作するように改変（主に受診に絶対必要な物以外を削除）
 出力先はシリアルからキーボードへ
 モード変更時の表示削除（受信時に現在のモードを表示）

***************************************************************************************/




#include  "DigiKeyboard.h"

#define DATA_LEN	16+2					// リモコンコードのデータ長(byte)+2
#define STRING_LEN	8						// 表示用の文字列最大値
#define BUTTON_PIN	2						// リモコン形式の変更用ボタン(Analog 5+14)
#define IR_IN    0       // 赤外線センサの接続ポート(Analog 1)



byte button(){ return(digitalRead(BUTTON_PIN)); }

// enum IR_TYPE{ AEHA=0, NEC=1, SIRC=2 };	// 家製協AEHA、NEC、SONY SIRC切り換え
#define AEHA        0
#define NEC         1
#define SIRC        2
byte type = AEHA;										// 赤外線方式

void setup() {
  DigiKeyboard.sendKeyStroke(0);

  pinMode(BUTTON_PIN, INPUT_PULLUP );
  pinMode(IR_IN, INPUT);
}

void loop(){
	byte i,len8;
	int len=0;											// 信号長
	byte data[DATA_LEN];
	char s[STRING_LEN];

	/* 赤外線リモコンコードの読み取り */
 
    DigiKeyboard.println("Wait");

	do{
		if( !button() ){
			type++;
			if(type>2) type=0;
  		delay(100); while(!button()); delay(100);
		}


		len = ir_read(data, DATA_LEN, type);
    if(len==-2)DigiKeyboard.println("SYN ERR");
	}while( len <= 0 );
	
    if(type == NEC) {
        DigiKeyboard.println("NEC");
      } else if( type == SIRC) {
         DigiKeyboard.println("SIRC");
      } else if( type == AEHA) {
        DigiKeyboard.println("AHEA");
      }

	
	len8 = (byte)(len/8);
	if(len%8 != 0) len8++;
	
	/* 結果表示 */
//DigiKeyboard.print("{");
  for(i=0; i<len8 ; i++){
    if(i>0) DigiKeyboard.print(',');
    sprintf(s,"0x%02X",data[i]);
    DigiKeyboard.print(s);
  }
  DigiKeyboard.print(" len->");
  DigiKeyboard.println(len,DEC);
}

